=== debian/changelog ===
deepin-log-viewer (6.1.18) unstable; urgency=medium

  * feat: Segmented export supports doc and xls formats for export
  * fix: Fix the issue of progress bar not displaying progress(Bug: 251937)
  * feat: Crash report content optimization(Task: 10320240422)
  * fix: Fix two security vulnerabilities(Bug: 253967)
  * fix: Optimized file reading speed
  * fix: Fix issues with abnormal search functionality
  * fix: fix compile problem on longarrch
  * fix: Security vulnerability reinforcement
  * fix: remove /bin/bash in service if necessary
  * fix: UI interface in English(Bug: 256789)
  * fix: The "level" on the page is displayed as "level"(Bug: 260291)

 -- houchengqiu <houchengqiu@uniontech.com>  Tue, 18 Jun 2024 16:00:41 +0800

deepin-log-viewer (6.1.17) unstable; urgency=medium

  * perf: Optimization of kernel/window management log memory usage
  * fix: Optimize search functionality
  * fix: Fix the issue of repeatedly popping up authentication windows(Bug: 251521)
  * fix: Fix the issue of segment export not being able to be cancelled(Bug: 251515)
  * fix: Refinement of kernel log segmentation export and cancellation of authentication logic(Bug: )
  * fix: Search function optimization 2nd && add logs

 -- houchengqiu <houchengqiu@uniontech.com>  Fri, 19 Apr 2024 13:22:11 +0800

deepin-log-viewer (6.1.16) unstable; urgency=medium

  * fix: The coredump reporter service switches from system mode to user mode
  * fix: Repair failed in building with a 64-bit time_t on a 32-bit(Bug: 250313)

 -- lijiaxuan <lijiaxuan@uniontech.com>  Fri, 12 Apr 2024 17:19:11 +0800

deepin-log-viewer (6.1.15) unstable; urgency=medium

  * feat: kwin crash log buried point report(Task: 330013)
  * chore: adjust coredump report interval
  * fix: Correction of abnormal last reporting time

 -- houchengqiu <houchengqiu@uniontech.com>  Thu, 21 Mar 2024 16:21:59 +0800

deepin-log-viewer (6.1.14) unstable; urgency=medium

  * fix: Fix the issue of filter option filtering without content when there is only one submodule(Bug: 244901)
  * fix: Delete dump temporary file from service backend(Bug: 241927)
  * fix: Remove the. config directory from the root directory(Bug: 244995)

 -- houchengqiu <houchengqiu@uniontech.com>  Wed, 13 Mar 2024 15:00:43 +0800

deepin-log-viewer (6.1.13) unstable; urgency=medium

  * fix: Resolve the issue of adding sudo not being able to export logs(Bug: 238985)
  * chore: [TS] Update international translation files(Bug: 193739)
  * fix: Resolve the issue of Sudo export logs being empty(Bug: 238985)
  * fix: Fix the issue of parent directory permissions being changed during export
  * fix: Unzip may overwrite linked file data(Bug: 243387)
  * fix: fix app name can not show chinese

 -- houchengqiu <houchengqiu@uniontech.com>  Thu, 22 Feb 2024 13:44:46 +0800

deepin-log-viewer (6.1.12) unstable; urgency=medium

  * fix: Add -v option version info(Bug: 236241)
  * fix: Adapt to the type of PGX log display(Bug: 240851)

 -- houchengqiu <houchengqiu@uniontech.com>  Thu, 01 Feb 2024 14:09:32 +0800

deepin-log-viewer (6.1.11) unstable; urgency=medium

  * fix: modify debug-config json

 -- houchengqiu <houchengqiu@uniontech.com>  Mon, 15 Jan 2024 14:10:59 +0800

deepin-log-viewer (6.1.10) unstable; urgency=medium

  * chore: Update version 6.1.10

 -- houchengqiu <houchengqiu@uniontech.com>  Thu, 11 Jan 2024 10:30:32 +0800

deepin-log-viewer (6.1.9) unstable; urgency=medium

  * feat: Log specification adaptation 2nd
  * feat: Log specification adaptation 2nd- merge export
  * fix: Resolve the issue of JSON configuration not being able to control application visibility(Bug: 237801)
  * feat: Debug mode log adaptation
  * fix: Resolve the issue of blank items in the application list(Bug: 237785)
  * feat: add package version information on crash burial point(Bug: 236991)
  * fix: Change the JSON visible field to 0 in debugging mode configuration(Bug: 238925)
  * fix: Fix the issue where using the - d parameter - m cannot export logs(Bug: 238967)

 -- houchengqiu <houchengqiu@uniontech.com>  Wed, 10 Jan 2024 11:46:04 +0800

deepin-log-viewer (6.1.8) unstable; urgency=medium

  * fix: Fix security vulnerabilities introduced by LD_PRELOAD 2nd(Bug: 234125)
  * chore: Optimization of output path whitelist inspection methods(Bug: 236471)

 -- houchengqiu <houchengqiu@uniontech.com>  Mon, 25 Dec 2023 17:17:00 +0800

deepin-log-viewer (6.1.7) unstable; urgency=medium

  * fix: Fix security vulnerabilities introduced by LD_PRELOAD(Bug: HW23-1232)
  * feat: Rectification of DBus security coding standards
  * fix: systemd service add memory limits 8G
  * fix: coredump map info only parsed in report coredump(Bug: 233653)
  * chore: Code review issue modification
  * fix: Resolve the issue of incomplete display of crash logs(Bug: 234131)

 -- houchengqiu <houchengqiu@uniontech.com>  Fri, 22 Dec 2023 13:21:34 +0800

deepin-log-viewer (6.1.6) unstable; urgency=medium

  * fix: clear qt warning logs
  * fix: Fix the issue of incomplete acquisition of file base names(Bug: 228425)
  * feat: report coredump add stackinfo
  * fix: not get core file maps (#237)
    Thanks to groveer
  * fix: Resolve the issue of failure to obtain stack maps address for crash information

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 30 Nov 2023 17:49:19 +0800

deepin-log-viewer (6.1.5) unstable; urgency=medium

  * fix: Adjust the display rules of application names in the application list(Bug: 223969)
  * feat: Rich command line export function
  * feat: Command line export by condition
  * fix: Remove command authentication
  * fix: CLI export type logs to diretory(Bug: 225107)
  * fix: CLI export return correct errcode(Bug: 225365)
  * fix: fix export specify app log failed problem(Bug: 225077)
  * fix: fix cli export kwin log failed problem(Bug: 225427)
  * fix: ix cli export to no-write dir can not quit(Bug: 225553)
  * fix: Add validity verification of cli export level parameters(Bug: 225567)

