=== debian/changelog ===
deepin-log-viewer (6.5.2) unstable; urgency=medium

  * adapt compact mode 

 -- houchengqiu <houchengqiu@uniontech.com>  Fri, 08 Nov 2024 13:49:23 +0800

deepin-log-viewer (6.5.1) unstable; urgency=medium

  * remove kwayland-shell env 

 -- Liu zheng <liuzheng@uniontech.com>  Wed, 06 Nov 2024 17:17:32 +0800

deepin-log-viewer (6.5.0) unstable; urgency=medium

  * chore: Code format organization
  * fix: Fix the issue of upgrade failure after enabling level protection(Bug: 258569)
  * fix: Fix crashes when there is no permission to view other logs(Bug: 266019)
  * fix: DBus calls authentication adds MNT check
  * feat: adapt treeland(Influence: Treeland)
  * fix: out-of-bounds access error

 -- renbin <renbin@uniontech.com>  Wed, 21 Aug 2024 15:34:48 +0800
