=== debian/changelog ===
deepin-log-viewer (6.5.4+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    + Upgrade to C++17 standard. (Closes: #1092336)
  * debian/control: Add new build-dep libgsettings-qt-dev.
  * debian/control: Add build-dep libgio-qt-dev.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Jan 2025 09:54:38 -0500

deepin-log-viewer (5.9.7+ds1-4) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 30 Oct 2024 15:37:24 -0400

deepin-log-viewer (5.9.7+ds1-4~exp1) experimental; urgency=medium

  * Team upload.
  * Test build with libxlsxwriter (>= 1.1.9).

 -- Boyuan Yang <byang@debian.org>  Tue, 29 Oct 2024 23:03:16 -0400

deepin-log-viewer (5.9.7+ds1-3) unstable; urgency=medium

  * Team upload.
  * debian/patches/0003-fix-32-64-time_t.patch: Cherry-pick upstream
    patch to fix build with 64-bit time_t build. (Closes: #1067560)

 -- Boyuan Yang <byang@debian.org>  Sat, 20 Apr 2024 09:34:08 -0400
