=== debian/control ===
Source: deepin-log-viewer
Section: misc
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Ma Aiguo <imaiguo@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libdframeworkdbus-dev,
 libdtkgui-dev,
 libdtkwidget-dev,
 libgio-qt-dev,
 libgmock-dev,
 libgsettings-qt-dev,
 libgtest-dev,
 libicu-dev,
 libkf5codecs-dev,
 libltdl-dev,
 libminizip-dev,
 libpolkit-qt5-1-dev,
 libqt5svg5-dev,
 libsystemd-dev,
 libxerces-c-dev,
 libxlsxwriter-dev (>= 1.1.9),
 libzip-dev,
 pkgconf,
 qt5-qmake,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 rapidjson-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/linuxdeepin/deepin-log-viewer
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-log-viewer.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-log-viewer

Package: deepin-log-viewer
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Log Viewer is a useful tool for viewing system logs
 Log viewer is a tool that collects logs generated when an application
 is running, for example, logs generated when operating system and
 applications start up and run. You can do trouble-shooting and solve
 problems quickly by analyzing logs.
